export type WeatherProvider = {
    getCurrentWeather(
        this: void,
        params: {
            longitude: number;
            latitude: number;
        },
    ): Promise<{
        temperature: string;
        apparentTemperature: string;
        relativeHumidity: string;
    }>;
};
